/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 1048 $ $LastChangedDate: 2002-10-26 23:19:49 +0200 (Sat, 26 Oct 2002) $
 *
 * Standard library for Gont, Sys module implementation.
 */

extern string Sys___get_argv(int idx);
extern int Sys___get_argc();
extern string Sys___get_environ(int idx);
extern int Sys___get_environc();

<string>Array::t argv = Array::init(Sys___get_argc(), Sys___get_argv);
<string>Array::t environ = Array::init(Sys___get_environc(), 
				       Sys___get_environ);
				       
bool env_cached = false;
<string>Hashtbl::t env_cache = Hashtbl::create(0);

string getenv(string v)
{
    if (env_cached)
	return Hashtbl::find(env_cache, v);

    def add(s) {
	if (String::contains(s, '=')) {
	    _ p = String::index(s, '=');
	    Hashtbl::add(env_cache, String::sub(s, 0, p - 1), 
			 String::sub(s, p, String::length(s) - p));
	} else {
	    Hashtbl::add(env_cache, s, "");
	}
    }

    Array::iter(add, environ);

    env_cached = true;

    return Hashtbl::find(env_cache, v);
}

// vim:sts=4:sw=4
